﻿using System;
using BeeDevelopment.Brazil;
using System.IO;
using System.Threading;

namespace ZEXALL {

	class Program {
		static void Main(string[] args) {
			var Test = new Zexall();
			for (; ; ) Test.FetchExecute(1000000);
		}
	}


	class Zexall : Z80A {

		// Memory emulation (64KB RAM, easy peasy).
		private byte[] Memory;
		public override void WriteMemory(ushort address, byte value) { this.Memory[address] = value; }
		public override byte ReadMemory(ushort address) { return this.Memory[address]; }

		// IO emulation.
		public override void WriteHardware(ushort port, byte value) {
			switch (port & 0xFF) {
				case 0xFC: // C for Control
					break;
				case 0xFD: // D for Data
					Console.Write((char)value);
					break;
			}
		}

		public Zexall() {
			this.Memory = new byte[64 * 1024];
			var Source = File.ReadAllBytes("zexall_sdsc.sms");
			Array.Copy(Source, this.Memory, Source.Length);
		}
	}
}
